% ARFace_PWCM_01.m
% using L2-norm minimization, Lp-norm comparison (multiple)
% with down-sampling
%% prepare for data 
% close all;
% clear all;

load('ARdata_occluded_results.mat');

% sub_index = [1:100];training_index = [1,2,3,4,14,15,16,17]; test_index = [8,11,21,24]; ARFace_PSVM_01_osc

isOSC = false;             % implement on OSC
isFillin = true;         % fill in the missing data using in-class average
isNormalizeU = true;     % normalize u by its norm
K_opt = 1;  % control the weights K
U_opt = 4;  % control U/u
isNormalizedDist = 0;

isLoadTrainingResults = 0; 
%%%%%%%%%%%%%%%%%%%%
isDisplay = true;         % need display detailed
isL2norm = true;           % use L1 or L2 norm to minimize
scale = 4;                 % down sample by scale*scale
isResize = true;           % if need resize the image and mask
use_face_oval = true;     % use oval face mask
use_normalization = false; % use illumination normalization
newsize = [29,21];       % new size of the image is isResize
%%%%%%%%%%%%%%%%%%%%
sub_index = [1:50];        % all males
sub_index = [51:100];      % all females
sub_index = [1:100];       % all males and females
sub_index = [1:25,51:75];  % first 25 male and first 25 female
%%%%%%%%%%%%%%%%%%
sub_index = [1:100];       % for PSVM only

training_index = [1:7]; test_index = [8:13];
training_index = [1:4]; test_index = [8,11];
training_index = [1,8,11]; test_index = [14];
training_index = [1,2,3,4,8,11]; test_index = [14,15,16,17];
training_index = [1:13]; test_index = [14:20];
training_index = [1:7]; test_index = [14:20];
training_index = [1,2,3,4,14,15,16,17]; test_index = [8,11,21,24];
training_index = [1,5,6]; test_index = [21:26];
training_index = [1]; test_index = [24];
training_index = [1,2,3,14,15,16]; test_index = [4,8,11,17,21,24];
training_index = [2,3,4]; test_index = [8,11];
training_index = [8,11]; test_index = [1,14];
training_index = [8,11]; test_index = [2,3,4];
training_index = [8,11,21,24]; test_index = [1,14];
training_index = [8,11]; test_index = [2,3,4,15,16,17];
training_index = [1:13]; test_index = [14:26];
training_index = [1]; test_index = [14,15,16,17];
training_index = [1:7]; test_index = [8:26];
training_index = [1]; test_index = [2,3,4];
training_index = [8,11,21,24]; test_index = [2,3,4,15,16,17];
training_index = [1]; test_index = [8,11,21,24];
%%%%%%%%%%%%%%%%
training_index = [8,11]; test_index = [1,14];
training_index = [8,11,21,24]; test_index = [1,14];
training_index = [1,2,3,4]; test_index = [14,15,16,17];
training_index = [1,2,3,8,11]; test_index = [14,15,16,21,24];
training_index = [1,8,11]; test_index = [2,3,4,14,15,16,17,21,24];
training_index = [1,2,3,8,11,14,15,16,21,24]; test_index = [4,17]; 
training_index = [1,2,3]; test_index = [4];
%%
trainingnum = length(training_index);
if isResize;     scale = 1;  end;
img_width = 156; img_height = 215; 
% diff_norm2 = [2, 1.8, 1.6, 1.5, 1.4, 1.2, 1.0, 0.8, 0.6, 0.5, 0.4, 0.2];
% diff_norm1 = [1.0, 0.8, 0.6, 0.5, 0.4, 0.2];
% if isL2norm
%     diff_norm = diff_norm2;
% else
%     diff_norm = diff_norm1;
% end;

%% generate face oval mask (elliptical mask)
if use_face_oval
    oval_mask  = false(img_height,img_width);
    % a = 90; b = 120; xc = 78; yc = 108; % a = 80; b = 110; xc = 78; yc = 108;
    a = 78; b = 107; xc = 78; yc = 108;
    for y = 1 : img_height
        for x = 1 : img_width
            if (x-xc)^2/a^2 + (y-yc)^2/b^2<=1
                oval_mask(y,x) = true;
            end
        end
    end
    oval_mask = oval_mask(1:scale:end,1:scale:end);
    if isResize; oval_mask = imresize(oval_mask,newsize); end;
    oval_mask1 = reshape(oval_mask,[],1);
    oval_index = find(oval_mask1);
else
    oval_mask  = true(img_height,img_width);
    oval_mask = oval_mask(1:scale:end,1:scale:end);
    if isResize; oval_mask = imresize(oval_mask,newsize); end;
    oval_mask1 = reshape(oval_mask,[],1);
    oval_index = find(oval_mask1);
end;
image_size = length(oval_index);
%%
trainingdata_all = single(zeros(image_size, length(sub_index)*length(training_index)));
INC_all = zeros(image_size, length(sub_index)*length(training_index));
non_occluded_index = [1:7,14:20]; occluded_index = [8:13, 21:26]; sample_index = [1:26];
%% collect data to get training data set
if ~isOSC
    imagefolder = 'ARCrop\'; occlusionfolder = 'AROcclusion\';
else
    imagefolder = 'ARCrop/'; occlusionfolder = 'AROcclusion/';
end;
loaddata = 0;
image_index = 0;
if loaddata == 0
    for ii = 1 : length(sub_index)
        sub = sub_index(ii)
        for index = training_index;
            index;
            if sub<=50
                filename = [imagefolder,'M-',num2str(sub,'%03d'),'-',num2str(index,'%02d'),'.bmp'];
            else
                filename = [imagefolder,'W-',num2str(sub-50,'%03d'),'-',num2str(index,'%02d'),'.bmp'];
            end;
            im = imread(filename);
            im = im(1:scale:end,1:scale:end,:); % down sampling
            im2 = single(rgb2gray(im))/256; 
            if isResize; im2 = imresize(im2,newsize); end;
            im2 = reshape(im2,[],1); %im2 = im2 - ones(size(im2))*mean(im2);
            im2 = im2(oval_index); % include face oval effect
            if ismember(index,occluded_index)
                occluded1 = occludedregion{sub,index};
            else
                occluded1 = false(img_height,img_width);
            end;
            occluded1 = occluded1(1:scale:end,1:scale:end);        % down sampling
            if isResize; occluded1 = imresize(occluded1,newsize); end;
            occluded1_1 = reshape(occluded1,[],1);        % reshape to a column
            occluded1_1 = occluded1_1(oval_index); % include face oval effect
            % subtract some illumination effect by unit std, zero mean
            if use_normalization
                seen_index = find(~occluded1_1);
                im2_mean = mean(im2(seen_index)); im2_std = std(im2(seen_index));
                im2 = (im2 - ones(size(im2))*im2_mean)/im2_std;
            end;
            image_index = image_index+1;
            trainingdata_all(:,image_index) = im2.*(1-occluded1_1);
            INC_all(:,image_index) = 1-occluded1_1;
        end
    end;

%     label_all = zeros(image_size,length(sub_index));
%     for j = 1 : length(sub_index)
%         INC = INC_all(:,trainingnum*(j-1)+1:trainingnum*j);
%         label = bin2dec(int2str(logical(INC)));
%         label_all(:,j) = label;
%     end;
else
    load('');
end;
%% pre-process:
% to delete the pixels which do not exist in any whole class.
mask_training = ones(size(INC_all,1),1); % this is also used to filter the testing image
for ii = 1 : length(sub_index)
    INC_cur = INC_all(:,trainingnum*(ii-1)+1:trainingnum*ii);
    mask_training = mask_training.*(sum(INC_cur')'>0);
end;
trainingdata_all = trainingdata_all(find(mask_training>0),:);
INC_all = INC_all(find(mask_training>0),:);

% fill in missing components
% isFillin = true;
d = size(trainingdata_all,1);
trainingdata_all_fillin = trainingdata_all;
if isFillin
    for ii = 1 : length(sub_index)
        X = trainingdata_all(:,trainingnum*(ii-1)+1:trainingnum*ii);
        M = INC_all(:,trainingnum*(ii-1)+1:trainingnum*ii);
        for i = 1 : size(X,2)
            if sum(M(:,i))<d
                missing_v = find(~M(:,i));
                x_new = X(:,i);
                for k = 1 : length(missing_v)
                    j = missing_v(k);
                    missing_h = find(~M(j,:));
                    existing_h = find(M(j,:));
                    t = X(j,existing_h).*M(j,existing_h);
                    x_new(j) = mean(t(find(t~=0)));
                end;
                X(:,i) = x_new;
            end;
        end;
        trainingdata_all_fillin(:,trainingnum*(ii-1)+1:trainingnum*ii) = X;
    end;
else
    %% 
end;

%% train: calculate PSVM hyperplanes
% isLoadTrainingResults = 0;
if ~isLoadTrainingResults
    hyperplane = cell(length(sub_index),2);
    for ii = 1 : length(sub_index)
        disp(['Training at case ',num2str(ii,'%d')]);
        X = trainingdata_all_fillin;
        M = INC_all;
        y = ones(1,size(X,2));
        y(trainingnum*(ii-1)+1:trainingnum*ii) = -1;
        % use standard SVM for non-missing case
        if sum(single(d) - single(sum(M)))==0
            [w,b] = PSVM_0(X, M, y);
        else
            [w,b] = PSVM(X, M, y, isNormalizeU, K_opt, U_opt);
        end;
        if w==Inf
            disp(['Not linear seperable at case ',num2str(ii,'%d')]);
            return;
        end;
        hyperplane{ii,1} = w;
        hyperplane{ii,2} = b;
    end;
else
    load('20080623_K1.mat');
end;
% return;



%% test: generate occluded mask
% occluded1 = zeros(img_height, img_width);
% occluded3 = zeros(img_height, img_width, 3);
% % down sampling
% occluded1 = zeros((img_height+1)/2, img_width/2);
% occluded3 = zeros((img_height+1)/2, img_width/2, 3);
% occluded = cell(length(sub_index),length(image_index));

result = [];
dist_all = [];
for ii = 1 : length(sub_index)
    sub = sub_index(ii)
    for index = test_index
        index;
        % read the testing image
        if ismember(index,[8:13,21:26])
            occluded1 = occludedregion{sub,index};
        else
            occluded1 = false(img_height,img_width);
        end;
        occluded1 = occluded1(1:scale:end,1:scale:end); % down sampling
        if isResize; occluded1 = imresize(occluded1,newsize); end;
        occluded1_1 = reshape(occluded1,[],1); % reshape to a column
        occluded1_1 = occluded1_1(oval_index); % include face oval effect
        if sub<=50
            filename = [imagefolder,'M-',num2str(sub,'%03d'),'-',num2str(index,'%02d'),'.bmp'];
        else
            filename = [imagefolder,'W-',num2str(sub-50,'%03d'),'-',num2str(index,'%02d'),'.bmp'];
        end;
        im = imread(filename);
        im = im(1:scale:end,1:scale:end,:); % down sampling
        im2 = single(rgb2gray(im))/256; 
        if isResize; im2 = imresize(im2,newsize); end;
        dim = size(im2); im2 = reshape(im2,[],1);
        im2 = im2(oval_index); % include face oval effect
        % subtract some illumination effect by unit std, zero mean
        if use_normalization
            seen_index = find(~occluded1_1);
            im2_mean = mean(im2(seen_index)); im2_std = std(im2(seen_index));
            im2 = (im2 - ones(size(im2))*im2_mean)/im2_std;
        end;
        INC_cur = 1-occluded1_1; % 0 for occluded, 1 for seen
        % finish reading the testing image
        
        % start testing
        test_cur = im2(find(mask_training>0),:);
        INC_cur = INC_cur(find(mask_training>0),:);
        dist_diff = zeros(1,length(sub_index));
        for jj = 1 : length(sub_index)
            % fill in the test data within the current class
            if sum(INC_cur)<length(INC_cur)
                test_cur_fillin1 = test_cur;
                test_cur_fillin2 = test_cur;
                missing_v = find(~INC_cur);
                for k = 1 : length(missing_v)
                    j = missing_v(k);
                    index1 = zeros(1,size(trainingdata_all,2));
                    index1(trainingnum*(jj-1)+1:trainingnum*jj) = 1;
                    index2 =  ones(1,size(trainingdata_all,2));
                    index2(trainingnum*(jj-1)+1:trainingnum*jj) = 0;
                    num1 = sum(INC_all(j,:).*index1);
                    test_cur_fillin1(j) = sum(trainingdata_all(j,:).*INC_all(j,:).*index1)/num1;
                    num2 = sum(INC_all(j,:).*index2);
                    test_cur_fillin2(j) = sum(trainingdata_all(j,:).*INC_all(j,:).*index2)/num2;
                end;
            else
                test_cur_fillin1 = test_cur;
                test_cur_fillin2 = test_cur;
            end;
            % calculate the distance from the hyperplane
            w = hyperplane{jj,1};
            b = hyperplane{jj,2};
            if isNormalizedDist
                dist1 = (-1)*(w'*test_cur_fillin1 - b)/norm(w);
                dist2 = (w'*test_cur_fillin2 - b)/norm(w);
            else
                dist1 = (-1)*(w'*test_cur_fillin1 - b);
                dist2 = (w'*test_cur_fillin2 - b);
            end;
            dist_diff(jj) = dist1-dist2;
        end;
        % determine the final classification
        dist_all = [dist_all;dist_diff];
        [dist_sort,IX] = sort(dist_diff,'descend');
        result = [result;[ii,IX]];
    end;
end;

%     length(find(result(:,1)-result(:,2)==0))
match = []; matchsub = []; matchcondition = [];

match = result(:,1)==result(:,2);
match = reshape(match,length(test_index),[]);
matchsub = sum(match);
matchcondition = sum(match');

matchresult = [];
matchresult(1,1) = length(find(result(:,1)-result(:,2)==0))/size(result,1);
matchresult(1,2) = length(find(result(:,1)-result(:,2)==0));

matchresult(1)
matchresult(2)
matchcondition

currenttime = datestr(now);
currenttime = currenttime(currenttime~=':')
save(['2008_PSVM_AR_',currenttime,'.mat'],...
    'isOSC','isDisplay','isResize','newsize','isFillin','isNormalizeU','K_opt','U_opt', ...
    'sub_index','training_index','test_index', ...
    'hyperplane', 'mask_training', ...
    'result','match','matchsub','matchcondition','matchresult');


% save(['2008_all_',currenttime,'.mat'],'result','match','matchsub','matchcondition','matchresult',...
% 'scale','use_face_oval','use_normalization','diff_norm','isOSC','isDisplay','isL2norm','isResize','newsize',...
% 'sub_index','training_index','test_index');

return;




%% return;