% SVM with missing data algorith with fast search algorithm
% standard SVM without missing data

function [w,b] = PSVM_0(X, M, y)
% X is the data after filling in
% M is the mask of visibility
% y is the label of classes (-1, +1)

d = size(X,1);

% figure();hold on;
% for i = 1 : size(X,2) 
%     if y(i)==-1 plot(X(1,i),X(2,i),'r.');
%     else if y(i)==1  plot(X(1,i),X(2,i),'b.'); end; end;
% end;
% hold off;

% construct Y
Y = zeros(size(X,2),d+1);
for i = 1 : size(X,2)
    Y(i,:) = [y(i)*X(:,i)',-y(i)];
end;
% I = eye(d);
onecol = ones(d,1);

counter_cvx = 0;
% the first run of CVX
tic;
cvx_begin
    variable w(d);
    variable b;
    % minimize(quad_form(w,I));
    minimize(quad_form(w,diag(onecol)));
    subject to
        Y*([w;b]) >= 1;
    cvx_quiet(true);
cvx_end
counter_cvx = counter_cvx+1;
t=toc
disp(['CVX runs ',num2str(counter_cvx,'%d'),' times by standard SVM!']);
if strcmp(cvx_status,'Solved')
    % step_diff = 1 - cvx_optval;
    results_final = cvx_optpnt;
    w = results_final.w;
    b = results_final.b;
else
    w = Inf;
    b = Inf;
end;

